VERSION 5.00
Begin VB.Form frmAddUserPersonalCalendarToOfficeCalendar 
   Caption         =   "Add Personal Calendar Items to Office Calendar"
   ClientHeight    =   6270
   ClientLeft      =   60
   ClientTop       =   390
   ClientWidth     =   7260
   BeginProperty Font 
      Name            =   "Tahoma"
      Size            =   12
      Charset         =   0
      Weight          =   700
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   ScaleHeight     =   6270
   ScaleWidth      =   7260
   StartUpPosition =   1  'CenterOwner
   Begin VB.ComboBox cboMailbox 
      BeginProperty Font 
         Name            =   "Tahoma"
         Size            =   12
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   405
      Left            =   2460
      TabIndex        =   5
      Top             =   300
      Width           =   3975
   End
   Begin VB.CommandButton cmdCancel 
      Caption         =   "Close"
      Height          =   495
      Left            =   180
      TabIndex        =   4
      Top             =   5520
      Width           =   1335
   End
   Begin VB.CommandButton cmdFinish 
      Caption         =   "Finish"
      Height          =   495
      Left            =   2060
      TabIndex        =   3
      Top             =   5520
      Width           =   1335
   End
   Begin VB.CommandButton cmdBack 
      Caption         =   "Back"
      Height          =   495
      Left            =   3940
      TabIndex        =   2
      Top             =   5520
      Width           =   1335
   End
   Begin VB.CommandButton cmdNext 
      Caption         =   "Next"
      Height          =   495
      Left            =   5820
      TabIndex        =   1
      Top             =   5520
      Width           =   1335
   End
   Begin VB.Label lblMailbox 
      Caption         =   "Mailbox Name:"
      BeginProperty Font 
         Name            =   "Tahoma"
         Size            =   12
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   375
      Left            =   480
      TabIndex        =   6
      Top             =   300
      Width           =   1695
   End
   Begin VB.Label lblTitle 
      Alignment       =   2  'Center
      Caption         =   "All Calendar Items for the User Selected Above Will Be Copied to the Office Calendar"
      BeginProperty Font 
         Name            =   "Tahoma"
         Size            =   15.75
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   1155
      Left            =   480
      TabIndex        =   0
      Top             =   3840
      Width           =   6015
   End
End
Attribute VB_Name = "frmAddUserPersonalCalendarToOfficeCalendar"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

' From Tom Howe (howe@controlcenter.com)
' Copyright 1998; All rights reserved.

Private Sub cmdBack_Click()

    Unload Me
    
End Sub

Private Sub cmdCancel_Click()

    Dim varReturn As Variant
    
    varReturn = MsgBox("You have not completed the administrative action. Do you want to shut down?", vbYesNo, "Action Not Completed!")
    
    If varReturn = 6 Then
    
        Unload Me
        
    Else
    
        ' Do Nothing
        
    End If
                
End Sub

Private Sub cmdFinish_Click()

    ' Add all of the items from the personal calendar
    ' in the Mailbox selected to the office calendar.
    
    Dim varReturn As Variant
        
    ' Make sure the user chooses a Mailbox from the list.
    If Me.cboMailbox = vbNullString Then
        MsgBox "You must choose a Mailbox from the list", vbCritical, "Choose Mailbox"
        GoTo ExitHere
    End If
    
    varReturn = MsgBox("Make sure you are logged in as Administrator on the " & _
        "Server. Also, all Mailboxes must be shared to the " & _
        "Admministrator profile for this application to work " & _
        "correctly. Do you want to continue?", vbYesNo, _
        "Application Warning!")
        
    If varReturn = 6 Then
    
      Dim objSession As MAPI.Session
      Dim objInfoStores As InfoStores
      Dim objInfoStore As InfoStore
      Dim objRootFolder As Folder
      Dim objFolders As Folders
      Dim objFolder As Folder
      Dim objCopiedMessage As Variant
      Dim objAddressList As AddressList
      Dim objAddressEntry As AddressEntry
      Dim strInitials As String
      Dim objMailBox As InfoStore
      Dim strMailBoxName As String
      Dim strMessageID As String
      Dim strFolderID As String
      Dim objMessages As Messages
      Dim objMessage As Message
      Dim objCalendarFolder As Folder
      Dim objCalendarMessages As Messages
      Dim objCalendarMessage As Message
      Dim strMailBox As String
      Dim objAppointments As Messages
      Dim i As Integer
      Dim strOfficeCalendarItem As String
      Dim objAddressEntries As AddressEntries
      Dim strUserName As String
      
      Set objSession = New MAPI.Session
      
      objSession.Logon ProfileName:="Administrator"
                  
      ' Reference the Recipient based on the Mailbox.
      ' Cannot use Sender of message since users can share
      ' calendars and add appointment items to others
      ' calendars.
      Set objMailBox = objSession.GetInfoStore()
    
      ' Reference the Global Address List
      Set objAddressList = objSession.AddressLists.Item("Global Address List")
      
      Set objAddressEntries = objAddressList.AddressEntries
    
      strUserName = Mid(Me.cboMailbox, 11, 99)   'objAddressEntry.Name
    
      Set objAddressEntry = objAddressList.AddressEntries(strUserName)
    
    ' Get the first three characters of the users name to put
    ' in front of the items added to the Office Calendar. The users
    ' name is the mailbox name, not the profile name.
    strInitials = UCase(Left(strUserName, 3))
    
      Set objInfoStores = objSession.InfoStores
      Set objInfoStore = objInfoStores.Item("Public Folders")
      Set objRootFolder = objInfoStore.RootFolder
      Set objFolders = objRootFolder.Folders
      
      Set objFolders = objFolders.Item(2).Folders 'All Public Folders.
    
      Set objFolder = objFolders.Item("Office Calendar")
         
      strFolderID = objFolder.ID
          
      strInitials = strInitials & "- "
               
      strMailBox = Me.cboMailbox
      
      Set objInfoStores = objSession.InfoStores
      Set objInfoStore = objInfoStores.Item(strMailBox)
      Set objRootFolder = objInfoStore.RootFolder
      Set objFolders = objRootFolder.Folders
      Set objCalendarFolder = objFolders.Item("Calendar")
          
      Set objCalendarMessages = objCalendarFolder.Messages
      
      ' The ConversationTopic property is used to hold
      ' a unique value (since this property is usually
      ' not used for appointment items.
      ' In the ConversationTopic property, include:
      ' Senders Name:Date/Time:Subject. The Date/Time
      ' is converted to a number. This is the unique
      ' value that will associated the item in the
      ' personal calendar and office calendar. When
      ' items are deleted or changed on the personal
      ' calendar, this value is used to sync the office
      ' calendar.
          
      For Each objCalendarMessage In objCalendarMessages
               
        ' When the calendar item was saved, code in the Outlook form
        ' presented the user with a dialog box asking if they wanted
        ' the item saved to the Office Calendar. If they chose "No",
        ' the Importance" property was set to 0, otherwise, the
        ' Importance property used the default value of 1
        If objCalendarMessage.Importance = 0 Then
            strOfficeCalendarItem = "N"
        Else
            strOfficeCalendarItem = "Y"
        End If
            
        If IsEmpty(objCalendarMessage.Categories) Then
            
            objCalendarMessage.ConversationTopic = strOfficeCalendarItem & ":" & objCalendarMessage.Sender & ":" & CDbl(objCalendarMessage.TimeCreated) & ":" & objCalendarMessage.Subject
        
            ' Save the changes to the Sender property for the
            ' calendar item added to the personal calendar.
            objCalendarMessage.Update
                                                  
            Set objCopiedMessage = objCalendarMessage.CopyTo(objFolder.ID)
            
            If objCopiedMessage.Sensitivity = 2 Then
                objCopiedMessage.Subject = "Private"
                objCopiedMessage.Text = "Private"
            End If
            
            objCopiedMessage.Subject = strInitials & objCopiedMessage.Subject
            
            objCopiedMessage.Update
            
        Else
        
            ' Do not add Holidays to Office Calendar.
            If objCalendarMessage.Categories()(0) = "Holiday" Then
                
                ' Do Nothing
                
            Else
            
                objCalendarMessage.ConversationTopic = strOfficeCalendarItem & ":" & objCalendarMessage.Sender & ":" & CDbl(objCalendarMessage.TimeCreated) & ":" & objCalendarMessage.Subject
        
                ' Save the changes to the Sender property for the
                ' calendar item added to the personal calendar.
                objCalendarMessage.Update
                                                  
                Set objCopiedMessage = objCalendarMessage.CopyTo(objFolder.ID)
            
                If objCopiedMessage.Sensitivity = 2 Then
                    objCopiedMessage.Subject = "Private"
                    objCopiedMessage.Text = "Private"
                End If
                
                objCopiedMessage.Subject = strInitials & objCopiedMessage.Subject
            
                objCopiedMessage.Update
                
            End If
            
        End If
        
      Next
      
      objSession.Logoff
      
      MsgBox "Office Calendar has been updated", vbCritical, "Import Complete"
      
      Set objCopiedMessage = Nothing
      Set objFolder = Nothing
      Set objFolders = Nothing
      Set objRootFolder = Nothing
      Set objInfoStore = Nothing
      Set objInfoStores = Nothing
      Set objAddressList = Nothing
      Set objAddressEntry = Nothing
      Set objSession = Nothing
      Set objSession = Nothing
      Set objMessages = Nothing
      Set objMessage = Nothing
      Set objCalendarFolder = Nothing
      Set objCalendarMessages = Nothing
      Set objCalendarMessage = Nothing
      Set objAppointments = Nothing
    
    Else
    
        ' Do Nothing
        
    End If
    
    Unload Me
    
ExitHere:
    
    On Error GoTo 0
    Exit Sub
    
End Sub

Private Sub Form_Load()

    Me.cmdBack.Enabled = True
    Me.cmdFinish.Enabled = True
    Me.cmdNext.Enabled = False
    Me.cmdCancel.Enabled = True
    
    Call LoadMailBoxCombo
    
End Sub

Private Sub LoadMailBoxCombo()

    Dim objSession As MAPI.Session ' assume logged on to valid session
            
    Set objSession = New MAPI.Session
    
    objSession.Logon ProfileName:="Administrator"   '"Tom"

    Dim i As Integer
    
    i = 1
    
    For i = i To objSession.InfoStores.Count
    
        If Left(objSession.InfoStores(i).Name, 7) = "Mailbox" Then
            Me.cboMailbox.AddItem objSession.InfoStores(i).Name
        End If
        
    Next
    
    objSession.Logoff
    
    Set objSession = Nothing

End Sub

