VERSION 5.00
Begin VB.Form frmCopyAllPersonalCalendarsOfficeCalendar 
   Caption         =   "Office Calendar Administration"
   ClientHeight    =   6270
   ClientLeft      =   60
   ClientTop       =   390
   ClientWidth     =   7260
   BeginProperty Font 
      Name            =   "Tahoma"
      Size            =   12
      Charset         =   0
      Weight          =   700
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   ScaleHeight     =   6270
   ScaleWidth      =   7260
   StartUpPosition =   1  'CenterOwner
   Begin VB.CommandButton cmdCancel 
      Caption         =   "Close"
      Height          =   495
      Left            =   180
      TabIndex        =   4
      Top             =   5520
      Width           =   1335
   End
   Begin VB.CommandButton cmdFinish 
      Caption         =   "Finish"
      Height          =   495
      Left            =   2060
      TabIndex        =   3
      Top             =   5520
      Width           =   1335
   End
   Begin VB.CommandButton cmdBack 
      Caption         =   "Back"
      Height          =   495
      Left            =   3940
      TabIndex        =   2
      Top             =   5520
      Width           =   1335
   End
   Begin VB.CommandButton cmdNext 
      Caption         =   "Next"
      Height          =   495
      Left            =   5820
      TabIndex        =   1
      Top             =   5520
      Width           =   1335
   End
   Begin VB.Label lblTitle 
      Alignment       =   2  'Center
      Caption         =   "All Personal Calendars Will Now be Copied to the Office Calendar"
      BeginProperty Font 
         Name            =   "Tahoma"
         Size            =   15.75
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   1155
      Left            =   480
      TabIndex        =   0
      Top             =   1320
      Width           =   6015
   End
End
Attribute VB_Name = "frmCopyAllPersonalCalendarsOfficeCalendar"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

' From Tom Howe (howe@controlcenter.com)
' Copyright 1998; All rights reserved.

Private Sub cmdBack_Click()

    Unload Me
    
End Sub

Private Sub cmdCancel_Click()

    Dim varReturn As Variant
    
    varReturn = MsgBox("You have not completed the administrative action. Do you want to shut down?", vbYesNo, "Action Not Completed!")
    
    If varReturn = 6 Then
    
        Unload Me
        
    Else
    
        ' Do Nothing
        
    End If
                
End Sub

Private Sub cmdFinish_Click()

    ' Add all of the items from ALL the personal calendars
    ' to the office calendar.
        
    Dim varReturn As Variant
        
    varReturn = MsgBox("Make sure you are logged in as Administrator on the " & _
        "Server. Also, all Mailboxes must be shared to the " & _
        "Admministrator profile for this application to work " & _
        "correctly. Do you want to continue?", vbYesNo, _
        "Application Warning!")
        
    If varReturn = 6 Then
        
        Dim objSession As MAPI.Session
        Dim objInfoStores As InfoStores
        Dim objInfoStore As InfoStore
        Dim objRootFolder As Folder
        Dim objFolders As Folders
        Dim objFolder As Folder
        Dim objCopiedMessage As Variant
        Dim objAddressList As AddressList
        Dim objAddressEntry As AddressEntry
        Dim objAddressEntries As AddressEntries
        Dim strInitials As String
        Dim objMailBox As InfoStore
        Dim strMailBoxName As String
        Dim strMessageID As String
        Dim objMessages As Messages
        Dim objMessage As Message
        Dim objCalendarFolder As Folder
        Dim objCalendarMessages As Messages
        Dim objCalendarMessage As Message
        Dim strMailBox As String
        Dim objAppointments As Messages
        Dim strUserName As String
        Dim strOfficeCalendarItem As String
        
        Set objSession = New MAPI.Session
        
        objSession.Logon ProfileName:="Administrator"
        
        Set objInfoStores = objSession.InfoStores
        Set objInfoStore = objInfoStores.Item("Public Folders")
        Set objRootFolder = objInfoStore.RootFolder
        Set objFolders = objRootFolder.Folders
        
        'All Public Folders.
        Set objFolders = objFolders.Item(2).Folders
        
        Set objFolder = objFolders.Item("Office Calendar")
            
        ' Reference the Recipient based on the Mailbox.
        ' Cannot use Sender of message since users can share
        ' calendars and add appointment items to others
        ' calendars.
        Set objMailBox = objSession.GetInfoStore()
        
        ' Reference the Global Address List
        Set objAddressList = objSession.AddressLists.Item("Global Address List")
          
        Set objAddressEntries = objAddressList.AddressEntries
        
        For Each objAddressEntry In objAddressEntries

                ' Only update if it is a user in the Global
                ' address list, not a Distribution List
                If objAddressEntry.DisplayType = 0 Then
                
                strUserName = objAddressEntry.Name
                
                Set objAddressEntry = objAddressList.AddressEntries(strUserName)
            
                ' Get the first three characters of the users name to put
                ' in front of the items added to the Office Calendar. The users
                ' name is the mailbox name, not the profile name.
                strInitials = UCase(Left(strUserName, 3))
                               
                strInitials = strInitials & "- "
                         
                strMailBox = "Mailbox - " & strUserName
                
                Set objInfoStores = objSession.InfoStores
                Set objInfoStore = objInfoStores.Item(strMailBox)
                Set objRootFolder = objInfoStore.RootFolder
                Set objFolders = objRootFolder.Folders
                Set objCalendarFolder = objFolders.Item("Calendar")
                    
                Set objCalendarMessages = objCalendarFolder.Messages
                
                ' The ConversationTopic property is used to hold
                ' a unique value (since this property is usually
                ' not used for appointment items.
                ' In the ConversationTopic property, include:
                ' Senders Name:Date/Time:Subject. The Date/Time
                ' is converted to a number. This is the unique
                ' value that will associated the item in the
                ' personal calendar and office calendar. When
                ' items are deleted or changed on the personal
                ' calendar, this value is used to sync the office
                ' calendar.
                    
                For Each objCalendarMessage In objCalendarMessages
                
                    ' When the calendar item was saved, code in the Outlook form
                    ' presented the user with a dialog box asking if they wanted
                    ' the item saved to the Office Calendar. If they chose "No",
                    ' the Importance" property was set to 0, otherwise, the
                    ' Importance property used the default value of 1
                    If objCalendarMessage.Importance = 0 Then
                        strOfficeCalendarItem = "N"
                    Else
                        strOfficeCalendarItem = "Y"
                    End If
                
                    If IsEmpty(objCalendarMessage.Categories) Then
                        
                        ' Some old messages do not have a sender causing a MAPI error
                        On Error Resume Next

                        objCalendarMessage.ConversationTopic = strOfficeCalendarItem & ":" & objCalendarMessage.Sender & ":" & CDbl(objCalendarMessage.TimeCreated) & ":" & objCalendarMessage.Subject
                    
                        ' Save the changes to the Sender property for the
                        ' calendar item added to the personal calendar.
                        objCalendarMessage.Update
                                                              
                        Set objCopiedMessage = objCalendarMessage.CopyTo(objFolder.ID)
                        
                        objCopiedMessage.Subject = strInitials & objCalendarMessage.Subject
                        
                        objCopiedMessage.Update
                        
                    Else
                    
                        ' Do not add Holidays to Office Calendar.
                        If objCalendarMessage.Categories()(0) = "Holiday" Then
                            
                            ' Do Nothing
                            
                        Else
                        
                            ' Some old messages do not have a sender causing a MAPI error
                            On Error Resume Next
                        
                            objCalendarMessage.ConversationTopic = strOfficeCalendarItem & ":" & objCalendarMessage.Sender & ":" & CDbl(objCalendarMessage.TimeCreated) & ":" & objCalendarMessage.Subject
                    
                            ' Save the changes to the Sender property for the
                            ' calendar item added to the personal calendar.
                            objCalendarMessage.Update
                                                              
                            Set objCopiedMessage = objCalendarMessage.CopyTo(objFolder.ID)
                        
                            objCopiedMessage.Subject = strInitials & objCalendarMessage.Subject
                        
                            objCopiedMessage.Update
                            
                        End If
                        
                    End If
                    
                Next
                
            End If
        
        Next
    
        objSession.Logoff
        
        MsgBox "Office Calendar has been updated", vbCritical, "Import Complete"
    
        Set objCopiedMessage = Nothing
        Set objFolder = Nothing
        Set objFolders = Nothing
        Set objRootFolder = Nothing
        Set objInfoStore = Nothing
        Set objInfoStores = Nothing
        Set objAddressList = Nothing
        Set objAddressEntry = Nothing
        Set objSession = Nothing
        Set objSession = Nothing
        Set objMessages = Nothing
        Set objMessage = Nothing
        Set objCalendarFolder = Nothing
        Set objCalendarMessages = Nothing
        Set objCalendarMessage = Nothing
        Set objAppointments = Nothing
            
    Else
    
        ' Do Nothing
        
    End If

    Unload Me
    
ExitHere:
    
    On Error GoTo 0
    Exit Sub
    
End Sub

Private Sub Form_Load()

    Me.cmdBack.Enabled = True
    Me.cmdFinish.Enabled = True
    Me.cmdNext.Enabled = False
    Me.cmdCancel.Enabled = True
    
End Sub

