VERSION 5.00
Begin VB.Form frmDeleteEventRegistrationFromOneUsersPersonalCalendar 
   Caption         =   "Office Calendar Administration"
   ClientHeight    =   6270
   ClientLeft      =   60
   ClientTop       =   390
   ClientWidth     =   7260
   BeginProperty Font 
      Name            =   "Tahoma"
      Size            =   12
      Charset         =   0
      Weight          =   700
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   ScaleHeight     =   6270
   ScaleWidth      =   7260
   StartUpPosition =   1  'CenterOwner
   Begin VB.ComboBox cboMailbox 
      BeginProperty Font 
         Name            =   "Tahoma"
         Size            =   12
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   405
      Left            =   2040
      Style           =   2  'Dropdown List
      TabIndex        =   0
      Top             =   300
      Width           =   5115
   End
   Begin VB.CommandButton cmdCancel 
      Caption         =   "Close"
      Height          =   495
      Left            =   180
      TabIndex        =   1
      Top             =   5640
      Width           =   1335
   End
   Begin VB.CommandButton cmdFinish 
      Caption         =   "Finish"
      Height          =   495
      Left            =   2060
      TabIndex        =   2
      Top             =   5640
      Width           =   1335
   End
   Begin VB.CommandButton cmdBack 
      Caption         =   "Back"
      Height          =   495
      Left            =   3940
      TabIndex        =   3
      Top             =   5640
      Width           =   1335
   End
   Begin VB.CommandButton cmdNext 
      Caption         =   "Next"
      Height          =   495
      Left            =   5820
      TabIndex        =   4
      Top             =   5640
      Width           =   1335
   End
   Begin VB.Label lblMailbox 
      Caption         =   "Mailbox Name:"
      BeginProperty Font 
         Name            =   "Tahoma"
         Size            =   12
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   375
      Left            =   240
      TabIndex        =   6
      Top             =   300
      Width           =   1755
   End
   Begin VB.Label lblTitle 
      Alignment       =   2  'Center
      Caption         =   "An Event Registration will be Added to the Personal Calendar Folder chosen Above"
      BeginProperty Font 
         Name            =   "Tahoma"
         Size            =   15.75
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   1155
      Left            =   240
      TabIndex        =   5
      Top             =   4320
      Width           =   6735
   End
End
Attribute VB_Name = "frmDeleteEventRegistrationFromOneUsersPersonalCalendar"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

' From Tom Howe (howe@controlcenter.com)
' Copyright 1998; All rights reserved.

' Some of the code from this module is used with permission from:
' Programming Collaborative Web Applications with
' Exchange 2000 Server by Mindy Martin (Microsoft)
' Copyright 2000. All rights reserved.

Const PROP_CONTENTCLASS = "urn:content-class:storeeventreg"
Const PROP_EVENTMETHOD As String = "http://schemas.microsoft.com/exchange/events/EventMethod"
Const PROP_SINKCLASS As String = "http://schemas.microsoft.com/exchange/events/SinkClass"
Const PROP_PRIORITY As String = "http://schemas.microsoft.com/exchange/events/priority"
Const PROP_MATCHSCOPE As String = "http://schemas.microsoft.com/exchange/events/matchScope"
Const PROP_CRITERIA As String = "http://schemas.microsoft.com/exchange/events/criteria"
Const PROP_ENABLED = "http://schemas.microsoft.com/exchange/events/enabled"

Private Sub cmdFinish_Click()

    ' Delete Event Registration for the mailbox selected.
        
    Dim varReturn As Variant
    Dim strFolderPath As String
    Dim strSQL As String
    Dim cnn As ADODB.Connection
    Dim rst As ADODB.Recordset
    
    On Error GoTo HandleErr
        
    ' Make sure the user chooses a Mailbox from the list.
    If Me.cboMailbox = vbNullString Then
        MsgBox "You must choose a Mailbox from the list", vbCritical, "Choose Mailbox"
        GoTo ExitHere
    End If
        
    varReturn = MsgBox("Make sure you are logged in as Administrator on the " & _
        "Server. Also, all Mailboxes must be shared to the " & _
        "Admministrator profile for this application to work " & _
        "correctly. Do you want to continue?", vbYesNo, _
        "Application Warning!")
        
    ' User chose "Yes"
    If varReturn = 6 Then

        strFolderPath = GetStorageName & "mbx/" & Me.cboMailbox.Text & "/Calendar"
        
        If Not cnn Is Nothing Then
           cnn.Close
        End If
   
        Set cnn = New ADODB.Connection
        With cnn
           .Provider = "exoledb.datasource"
           .Open strFolderPath
        End With
   
        ' Build the SQL query
        strSQL = "Select " & _
           AddQuotes("DAV:displayname") & ", " & _
           AddQuotes("DAV:comment") & ", " & _
           AddQuotes(PROP_EVENTMETHOD) & ", " & _
           AddQuotes(PROP_SINKCLASS) & ", " & _
           AddQuotes(PROP_CRITERIA) & ", " & _
           AddQuotes(PROP_MATCHSCOPE) & ", " & _
           AddQuotes(PROP_PRIORITY) & ", " & _
           AddQuotes(PROP_ENABLED) & ", " & _
           AddQuotes("DAV:href")
        strSQL = strSQL & " FROM SCOPE('SHALLOW traversal of " & _
            AddQuotes(strFolderPath) & "')"
        strSQL = strSQL & " WHERE " & AddQuotes("DAV:contentclass") & _
           " = '" & PROP_CONTENTCLASS & "'"
      
        ' Create a new recordset object
        Set rst = New ADODB.Recordset
        With rst
           'Open recordset based on the SQL string
           .Open strSQL, cnn
        End With
      
        Do Until rst.EOF
            rst.Delete
            rst.MoveNext
        Loop
        
    End If
    
    MsgBox "The Events have been unregistered for the mailbox you selected", vbCritical, "Event Unregistration Complete"
    
    rst.Close
    cnn.Close
    
    Unload Me
    
ExitHere:
    
    On Error Resume Next
    Set rst = Nothing
    Set cnn = Nothing
    
    Exit Sub
    
HandleErr:

    MsgBox "Error: " & Err.Description & " (" & Err.Number & ")"
   
   Resume ExitHere
    
End Sub

Private Sub Form_Load()

    Me.cmdBack.Enabled = True
    Me.cmdFinish.Enabled = True
    Me.cmdNext.Enabled = False
    Me.cmdCancel.Enabled = True
    
    Call LoadMailBoxCombo
        
End Sub

Private Sub LoadMailBoxCombo()

    Dim objSession As MAPI.Session
    Dim i As Integer
            
    ' Assume logged into a valid session.
    Set objSession = New MAPI.Session

    ' Change login profile for your office
    objSession.Logon ProfileName:="Administrator"
    
    i = 1
    
    For i = i To objSession.InfoStores.Count
    
        If Left(objSession.InfoStores(i).Name, 7) = "Mailbox" Then
            Me.cboMailbox.AddItem Mid(objSession.InfoStores(i).Name, 11)
        End If
        
    Next
    
    objSession.Logoff
    
    Set objSession = Nothing

End Sub

Private Sub cmdBack_Click()

    Unload Me
    
End Sub

Private Sub cmdCancel_Click()

    Dim varReturn As Variant
    
    varReturn = MsgBox("You have not completed the administrative action. Do you want to shut down?", vbYesNo, "Action Not Completed!")
    
    ' User chose "Yes"
    If varReturn = 6 Then
    
        Unload Me
        
    Else
    
        ' Do Nothing
        
    End If
        
End Sub

