VERSION 5.00
Begin VB.Form frmDeleteSingleUsersItemsFromOfficeCalendar 
   Caption         =   "Office Calendar Administration"
   ClientHeight    =   6270
   ClientLeft      =   60
   ClientTop       =   435
   ClientWidth     =   7260
   BeginProperty Font 
      Name            =   "Tahoma"
      Size            =   12
      Charset         =   0
      Weight          =   700
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   ScaleHeight     =   6270
   ScaleWidth      =   7260
   StartUpPosition =   1  'CenterOwner
   Begin VB.ComboBox cboMailbox 
      BeginProperty Font 
         Name            =   "Tahoma"
         Size            =   12
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   405
      Left            =   2460
      TabIndex        =   5
      Top             =   300
      Width           =   3975
   End
   Begin VB.CommandButton cmdCancel 
      Caption         =   "Close"
      Height          =   495
      Left            =   180
      TabIndex        =   4
      Top             =   5520
      Width           =   1335
   End
   Begin VB.CommandButton cmdFinish 
      Caption         =   "Finish"
      Height          =   495
      Left            =   2060
      TabIndex        =   3
      Top             =   5520
      Width           =   1335
   End
   Begin VB.CommandButton cmdBack 
      Caption         =   "Back"
      Height          =   495
      Left            =   3940
      TabIndex        =   2
      Top             =   5520
      Width           =   1335
   End
   Begin VB.CommandButton cmdNext 
      Caption         =   "Next"
      Height          =   495
      Left            =   5820
      TabIndex        =   1
      Top             =   5520
      Width           =   1335
   End
   Begin VB.Label lblMailbox 
      Caption         =   "Mailbox Name:"
      BeginProperty Font 
         Name            =   "Tahoma"
         Size            =   12
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   375
      Left            =   480
      TabIndex        =   6
      Top             =   300
      Width           =   1695
   End
   Begin VB.Label lblTitle 
      Alignment       =   2  'Center
      Caption         =   "All Items Will Now Be Deleted From The Office Calendar For The User Selected Above"
      BeginProperty Font 
         Name            =   "Tahoma"
         Size            =   15.75
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   1155
      Left            =   480
      TabIndex        =   0
      Top             =   3840
      Width           =   6015
   End
End
Attribute VB_Name = "frmDeleteSingleUsersItemsFromOfficeCalendar"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

' From Tom Howe (howe@controlcenter.com)
' Copyright 1998; All rights reserved.

Private Sub cmdBack_Click()

    Unload Me
    
End Sub

Private Sub cmdCancel_Click()

    Dim varReturn As Variant
    
    varReturn = MsgBox("You have not completed the administrative action. Do you want to shut down?", vbYesNo, "Action Not Completed!")
    
    If varReturn = 6 Then
    
        Unload Me
        
    Else
    
        ' Do Nothing
        
    End If
                
End Sub

Private Sub cmdFinish_Click()

    ' Delete all Items from the Office Calendar. For
    ' the users selected in the combo box.
        
    Dim varReturn As Variant
        
    ' Make sure the user chooses a Mailbox from the list.
    If Me.cboMailbox = vbNullString Then
        MsgBox "You must choose a Mailbox from the list", vbCritical, "Choose Mailbox"
        GoTo ExitHere
    End If
    
    varReturn = MsgBox("Make sure you are logged in as Administrator on the " & _
        "Server. Also, all Mailboxes must be shared to the " & _
        "Admministrator profile for this application to work " & _
        "correctly. Do you want to continue?", vbYesNo, _
        "Application Warning!")
        
    If varReturn = 6 Then
    
        Me.MousePointer = vbHourglass
        
        Dim objSession As MAPI.Session
        Dim objInfoStores As InfoStores
        Dim objInfoStore As InfoStore
        Dim objRootFolder As Folder
        Dim objFolders As Folders
        Dim objFolder As Folder
        Dim objMessages As Messages
        Dim objMessage As Message
        Dim objMessageFilter As MessageFilter
        Dim objMailBox As InfoStore
        Dim objAddressList As AddressList
        Dim objAddressEntries As AddressEntries
        Dim objAddressEntry As AddressEntry
        Dim lngSize As Long
        Dim strUserName As String
        Dim strInitials As String
        Dim i As Integer
     
        Set objSession = New MAPI.Session
        
        objSession.Logon ProfileName:="Administrator"
            
        ' Reference the Recipient based on the Mailbox.
        ' Cannot use Sender of message since users can share
        ' calendars and add appointment items to others
        ' calendars.
        Set objMailBox = objSession.GetInfoStore()
    
        ' Reference the Global Address List
        Set objAddressList = objSession.AddressLists.Item("Global Address List")
      
        Set objAddressEntries = objAddressList.AddressEntries
    
        strUserName = Mid(Me.cboMailbox, 11, 99)   'objAddressEntry.Name
    
        Set objAddressEntry = objAddressList.AddressEntries(strUserName)
    
        ' Get the first three characters of the users name to put
        ' in front of the items added to the Office Calendar. The users
        ' name is the mailbox name, not the profile name.
        strInitials = UCase(Left(strUserName, 3))
        strInitials = strInitials & "- "
    
        Set objInfoStores = objSession.InfoStores
        Set objInfoStore = objInfoStores.Item("Public Folders")
        Set objRootFolder = objInfoStore.RootFolder
        Set objFolders = objRootFolder.Folders
        
        'All Public Folders.
        Set objFolders = objFolders.Item(2).Folders
    
        Set objFolder = objFolders.Item("Office Calendar")
         
        Set objMessages = objFolder.Messages
                                   
        Set objMessageFilter = objMessages.Filter

        objMessageFilter.Subject = Left(strInitials, 4)

        For Each objMessage In objMessages

            objMessage.Delete

        Next
                     
        objSession.Logoff
        
        MsgBox "The selected Items have been deleted from the Office Calendar", vbCritical, "Items Deleted Successfully"
        
        Set objFolder = Nothing
        Set objFolders = Nothing
        Set objRootFolder = Nothing
        Set objInfoStore = Nothing
        Set objInfoStores = Nothing
        Set objSession = Nothing
        Set objSession = Nothing
        Set objMessages = Nothing
        Set objMessage = Nothing
        Set objMessageFilter = Nothing
        
        Me.MousePointer = vbDefault
        
    Else
    
        ' Do Nothing
        
    End If
    
    Unload Me
    
ExitHere:
    Exit Sub
    
End Sub

Private Sub Form_Load()

    Me.cmdBack.Enabled = True
    Me.cmdFinish.Enabled = True
    Me.cmdNext.Enabled = False
    Me.cmdCancel.Enabled = True
    
    Call LoadMailBoxCombo
    
End Sub

Private Sub LoadMailBoxCombo()

    Dim objSession As MAPI.Session ' assume logged on to valid session
            
    Set objSession = New MAPI.Session
    
    objSession.Logon ProfileName:="Administrator"

    Dim i As Integer
    
    i = 1
    
    For i = i To objSession.InfoStores.Count
    
        If Left(objSession.InfoStores(i).Name, 7) = "Mailbox" Then
            Me.cboMailbox.AddItem objSession.InfoStores(i).Name
        End If
        
    Next
    
    objSession.Logoff
    
    Set objSession = Nothing

End Sub

