VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "SyncEvents"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

' From Tom Howe (howe@controlcenter.com)
' Copyright 2000; All rights reserved.

Implements Exoledb.IExStoreSyncEvents

' *************************************************************************************** '
' Synchronous Delete Event
' *************************************************************************************** '
Private Sub IExStoreSyncEvents_OnSyncDelete( _
    ByVal pEventInfo As Exoledb.IExStoreEventInfo, _
    ByVal bstrURLItem As String, _
    ByVal lFlags As Long)
    
    ' Use transactions!
    
    If lFlags And EVT_SYNC_BEGIN Then
   
        ' This is the first time the event sink has been called. Here, you
        ' can access values from the deleted item.
   
        ' Call a procedure to delete the item from the Office Calendar.
        Call DeleteItem(bstrURLItem)
              
   ElseIf lFlags And EVT_SYNC_COMMITTED Then
   
        ' This is the second time the sink has been called. The delete
        ' has been committed. You cannot make changes to the resource.
   
        ' Put code here
   
   ElseIf lFlags And EVT_SYNC_ABORTED Then
   
        ' The deleted has been aborted. You cannot make
        ' changes to the resource.
   
        ' Put code here
   
   End If
   
End Sub

' *************************************************************************************** '
' Synchronous Save Event
' *************************************************************************************** '
Private Sub IExStoreSyncEvents_OnSyncSave( _
    ByVal pEventInfo As Exoledb.IExStoreEventInfo, _
    ByVal bstrURLItem As String, _
    ByVal lFlags As Long)
    
    ' Use transactions!
    
    ' You might also want to test for synchronized items
    ' using lFlags.
    
    If lFlags And EVT_SYNC_BEGIN Then
    
        ' This is the first time the event sink has been called.
        ' You can access the resource.
    
        ' Put code here
    
    ElseIf lFlags And EVT_SYNC_COMMITTED Then
    
        ' This is the second time the event sink has been called.
        ' You cannot make changes to the resource.
    
        ' Put code here
    
    ElseIf lFlags And EVT_SYNC_ABORTED Then
        
        ' The Save has been aborted. You cannot make changes to the resource.
    
        ' Put code here
    
    End If

End Sub








