VERSION 5.00
Begin VB.Form frmDeleteAllItemsFromOfficeCalendar 
   Caption         =   "Office Calendar Administration"
   ClientHeight    =   6270
   ClientLeft      =   60
   ClientTop       =   390
   ClientWidth     =   7260
   BeginProperty Font 
      Name            =   "Tahoma"
      Size            =   12
      Charset         =   0
      Weight          =   700
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   ScaleHeight     =   6270
   ScaleWidth      =   7260
   StartUpPosition =   1  'CenterOwner
   Begin VB.CommandButton cmdCancel 
      Caption         =   "Close"
      Height          =   495
      Left            =   180
      TabIndex        =   4
      Top             =   5520
      Width           =   1335
   End
   Begin VB.CommandButton cmdFinish 
      Caption         =   "Finish"
      Height          =   495
      Left            =   2060
      TabIndex        =   3
      Top             =   5520
      Width           =   1335
   End
   Begin VB.CommandButton cmdBack 
      Caption         =   "Back"
      Height          =   495
      Left            =   3940
      TabIndex        =   2
      Top             =   5520
      Width           =   1335
   End
   Begin VB.CommandButton cmdNext 
      Caption         =   "Next"
      Height          =   495
      Left            =   5820
      TabIndex        =   1
      Top             =   5520
      Width           =   1335
   End
   Begin VB.Label lblTitle 
      Alignment       =   2  'Center
      Caption         =   "All Items Will Now Be Deleted From The Office Calendar"
      BeginProperty Font 
         Name            =   "Tahoma"
         Size            =   15.75
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   1155
      Left            =   480
      TabIndex        =   0
      Top             =   1320
      Width           =   6015
   End
End
Attribute VB_Name = "frmDeleteAllItemsFromOfficeCalendar"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

' From Tom Howe (howe@controlcenter.com)
' Copyright 1998; All rights reserved.

Private Sub cmdBack_Click()

    Unload Me
    
End Sub

Private Sub cmdCancel_Click()

    Dim varReturn As Variant
    
    varReturn = MsgBox("You have not completed the administrative action. Do you want to shut down?", vbYesNo, "Action Not Completed!")
    
    If varReturn = 6 Then
    
        Unload Me
        
    Else
    
        ' Do Nothing
        
    End If
                
End Sub

Private Sub cmdFinish_Click()

    ' Delete all Items from the Office Calendar. This is better
    ' than deleting the Office Calendar folder since all of the
    ' users at the office have a shortcut on their Outlook Bar
    ' to the Office Calendar. If the Office Calendar folder is
    ' deleted and recreated, all users have to recreate the
    ' shortcut.
        
    Dim varReturn As Variant
    
    varReturn = MsgBox("Make sure you are logged in as Administrator on the " & _
        "Server. Also, all Mailboxes must be shared to the " & _
        "Admministrator profile for this application to work " & _
        "correctly. Do you want to continue?", vbYesNo, _
        "Application Warning!")
        
    If varReturn = 6 Then
    
        Me.MousePointer = vbHourglass
        
        Dim objSession As MAPI.Session
        Dim objInfoStores As InfoStores
        Dim objInfoStore As InfoStore
        Dim objRootFolder As Folder
        Dim objFolders As Folders
        Dim objFolder As Folder
        Dim objMessages As Messages
        Dim objMessage As Message
        Dim lngSize As Long
        Dim i As Integer
     
        Set objSession = New MAPI.Session
        
        objSession.Logon ProfileName:="Administrator"
            
        Set objInfoStores = objSession.InfoStores
        Set objInfoStore = objInfoStores.Item("Public Folders")
        Set objRootFolder = objInfoStore.RootFolder
        Set objFolders = objRootFolder.Folders
        
        'All Public Folders.
        Set objFolders = objFolders.Item(2).Folders
      
        Set objFolder = objFolders.Item("Office Calendar")
        
        Set objMessages = objFolder.Messages
        
        lngSize = objMessages.Count
        
        i = 1
        
        For i = 1 To lngSize
        
            Set objMessage = objMessages(lngSize - i + 1)
            
            objMessage.Delete
            
        Next i
          
        objSession.Logoff
        
        MsgBox "All Items have been deleted from the Office Calendar", vbCritical, "Items Deleted Successfully"
        
        Set objFolder = Nothing
        Set objFolders = Nothing
        Set objRootFolder = Nothing
        Set objInfoStore = Nothing
        Set objInfoStores = Nothing
        Set objSession = Nothing
        Set objSession = Nothing
        Set objMessages = Nothing
        Set objMessage = Nothing
        
        Me.MousePointer = vbDefault
        
    Else
    
        ' Do Nothing
        
    End If
    
    Unload Me
    
End Sub

Private Sub Form_Load()

    Me.cmdBack.Enabled = True
    Me.cmdFinish.Enabled = True
    Me.cmdNext.Enabled = False
    Me.cmdCancel.Enabled = True
    
End Sub

