VERSION 5.00
Object = "{0ECD9B60-23AA-11D0-B351-00A0C9055D8E}#6.0#0"; "MSHFLXGD.OCX"
Begin VB.Form frmDisplayEventRegistrations 
   Caption         =   "Event Registrations"
   ClientHeight    =   7245
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   12900
   LinkTopic       =   "Form1"
   ScaleHeight     =   7245
   ScaleWidth      =   12900
   StartUpPosition =   2  'CenterScreen
   Begin VB.CommandButton cmdDisplayEvents 
      Caption         =   "Display Events"
      Default         =   -1  'True
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   13.5
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   495
      Left            =   10320
      TabIndex        =   2
      Top             =   6480
      Width           =   2415
   End
   Begin MSHierarchicalFlexGridLib.MSHFlexGrid ctlGrid 
      Height          =   5895
      Left            =   240
      TabIndex        =   1
      Top             =   240
      Width           =   12375
      _ExtentX        =   21828
      _ExtentY        =   10398
      _Version        =   393216
      Cols            =   3
      FixedCols       =   0
      ScrollBars      =   2
      _NumberOfBands  =   1
      _Band(0).Cols   =   3
   End
   Begin VB.CommandButton cmdClose 
      Caption         =   "Close"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   13.5
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   495
      Left            =   7560
      TabIndex        =   0
      Top             =   6480
      Width           =   2415
   End
End
Attribute VB_Name = "frmDisplayEventRegistrations"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

' From Tom Howe (howe@controlcenter.com)
' Copyright 1998; All rights reserved.

' Some of the code from this module is used with permission from:
' Programming Collaborative Web Applications with
' Exchange 2000 Server by Mindy Martin (Microsoft)
' Copyright 2000. All rights reserved.

Const PROP_CONTENTCLASS = "urn:content-class:storeeventreg"
Const PROP_EVENTMETHOD As String = "http://schemas.microsoft.com/exchange/events/EventMethod"
Const PROP_SINKCLASS As String = "http://schemas.microsoft.com/exchange/events/SinkClass"
Const PROP_PRIORITY As String = "http://schemas.microsoft.com/exchange/events/priority"
Const PROP_MATCHSCOPE As String = "http://schemas.microsoft.com/exchange/events/matchScope"
Const PROP_CRITERIA As String = "http://schemas.microsoft.com/exchange/events/criteria"
Const PROP_ENABLED = "http://schemas.microsoft.com/exchange/events/enabled"

Private Sub cmdDisplayEvents_Click()

    Dim varReturn As Variant
    Dim strFolderPath As String
    Dim strName As String
    Dim strSQL As String
    Dim cnn As ADODB.Connection
    Dim rst As ADODB.Recordset
    Dim objSession As MAPI.Session
    Dim i As Integer
    
    On Error GoTo HandleErr
                
    varReturn = MsgBox("Make sure you are logged in as Administrator on the " & _
        "Server. Also, all Mailboxes must be shared to the " & _
        "Admministrator profile for this application to work " & _
        "correctly. Do you want to continue?", vbYesNo, _
        "Application Warning!")
        
    ' User chose "Yes"
    If varReturn = 6 Then
   
        ' Assume logged into a valid session.
        Set objSession = New MAPI.Session
    
        ' Change login profile for your office
        objSession.Logon ProfileName:="Administrator"
        
        i = 1
        
        For i = i To objSession.InfoStores.Count
        
            If Left(objSession.InfoStores(i).Name, 7) = "Mailbox" Then
                
                strName = Mid(objSession.InfoStores(i).Name, 11)

                strFolderPath = GetStorageName & "mbx/" & strName & "/Calendar"
                 
                If Not cnn Is Nothing Then cnn.Close
            
                Set cnn = New ADODB.Connection
                 
                With cnn
                    .Provider = "exoledb.datasource"
                    .Open strFolderPath
                End With
            
                ' Build the SQL query
                strSQL = "Select " & _
                    AddQuotes("DAV:displayname") & ", " & _
                    AddQuotes(PROP_EVENTMETHOD) & ", " & _
                    AddQuotes(PROP_SINKCLASS)
                strSQL = strSQL & " FROM SCOPE('SHALLOW traversal of " & _
                     AddQuotes(strFolderPath) & "')"
                strSQL = strSQL & " WHERE " & AddQuotes("DAV:contentclass") & _
                    " = '" & PROP_CONTENTCLASS & "'"
                    
'                ' Build the SQL query
'                strSQL = "Select " & _
'                    AddQuotes("DAV:displayname") & ", " & _
'                    AddQuotes("DAV:comment") & ", " & _
'                    AddQuotes(PROP_EVENTMETHOD) & ", " & _
'                    AddQuotes(PROP_SINKCLASS) & ", " & _
'                    AddQuotes(PROP_CRITERIA) & ", " & _
'                    AddQuotes(PROP_MATCHSCOPE) & ", " & _
'                    AddQuotes(PROP_PRIORITY) & ", " & _
'                    AddQuotes(PROP_ENABLED) & ", " & _
'                    AddQuotes("DAV:href")
'                strSQL = strSQL & " FROM SCOPE('SHALLOW traversal of " & _
'                     AddQuotes(strFolderPath) & "')"
'                strSQL = strSQL & " WHERE " & AddQuotes("DAV:contentclass") & _
'                    " = '" & PROP_CONTENTCLASS & "'"
               
                ' Create a new recordset object
                Set rst = New ADODB.Recordset
                With rst
                    'Open recordset based on the SQL string
                    .Open strSQL, cnn
                End With
               
                Set Me.ctlGrid.DataSource = rst
                        
            End If
            
        Next
        
    End If
        
    ' Set the Columns Row color to yellow.
    Me.ctlGrid.BackColorHeader(0) = vbYellow
    
    ' Loop through all of the columns and set the width.
    For i = 0 To Me.ctlGrid.Cols - 1
        Me.ctlGrid.ColWidth(i) = 4200
    Next i
        
    rst.Close
    cnn.Close
    objSession.Logoff
           
ExitHere:
    
    On Error Resume Next
    Set rst = Nothing
    Set cnn = Nothing
    Set objSession = Nothing
    
    Exit Sub
    
HandleErr:

    MsgBox "Error: " & Err.Description & " (" & Err.Number & ")"
   
   Resume ExitHere

End Sub

Private Sub cmdClose_Click()
    Unload Me
End Sub

