VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "AsyncEvents"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

' From Tom Howe (howe@controlcenter.com)
' Copyright 2000; All rights reserved.

Implements Exoledb.IExStoreAsyncEvents

' *************************************************************************************** '
' Asynchronous Save Event
' *************************************************************************************** '
Private Sub IExStoreAsyncEvents_OnSave( _
   ByVal pEventInfo As Exoledb.IExStoreEventInfo, _
   ByVal bstrURLItem As String, _
   ByVal lFlags As Long)

   ' If the event it triggered by replication, do not run the code.
   If Not lFlags And EVT_REPLICATED_ITEM Then
        
        ' This is a new item, not a changed item.
        If lFlags And EVT_NEW_ITEM Then
                    
            ' Call a procedure to create the item on the Office Calendar.
            Call AddItem(bstrURLItem)
                               
        ' This is a changed item, not a new item.
        Else
        
            ' Since the personal calendar appointment has been changed,
            ' delete the item from the personal calendar and recreate it.
        
            ' Call a procedure to delete the item from the Office Calendar.
            Call DeleteItem(bstrURLItem)
                                            
            ' Call a procedure to recreate the item on the Office Calendar.
            Call AddItem(bstrURLItem)
        
        End If
                
    End If
        
End Sub

' *************************************************************************************** '
' Asynchronous Delete Event
' *************************************************************************************** '
Private Sub IExStoreAsyncEvents_OnDelete( _
   ByVal pEventInfo As Exoledb.IExStoreEventInfo, _
   ByVal bstrURLItem As String, _
   ByVal lFlags As Long)

    ' Put code here
    
End Sub


